# :pencil: MyNotes
**MyNotes** is a Demo app which demonstrates the use of MVVM architecture, Dependency Injection, Navigation Component Library, Room Database, LiveData, Coroutines and other **Modern Android Development** Practices. 

# :movie_camera: Working Demo
<img src="https://user-images.githubusercontent.com/49483235/155854353-e6d00544-5e70-4d78-8d1b-9623299b68f2.gif" width="600" height="700">

# 🗡️ Dependency Injection
The project uses [Hilt](https://developer.android.com/training/dependency-injection/hilt-android) for Dependency Injection :syringe: If you are a begginer with
MVVM then I highly recommend to start with Manual Dependency injection method and then move to Hilt, see branch [***`di-ManualInjection`***](https://github.com/avidraghav/MyNotes/tree/di-ManualInjection) for implementation

# :wrench: Built With
- [Kotlin](https://kotlinlang.org/) - Programming Language Used in the app.
- [Navigation Component Library](https://developer.android.com/guide/navigation) - For setting up app's navigation.
- [Room Database](https://developer.android.com/training/data-storage/room) - For persisting data/tasks in device's local storage.
- [Kotlin Coroutines](https://kotlinlang.org/docs/coroutines-overview.html) - To execute code asynchronously.
- [Flow](https://kotlinlang.org/docs/reference/coroutines/flow.html) - In the simplest of ways consider this as a pipe through which the data flows in the app, by using flow
   a developer doesn't need to refresh variables which contain data.  
- [LiveData](https://developer.android.com/topic/libraries/architecture/livedata) - Used to observe the data on the UI layer
- [ViewModel](https://developer.android.com/topic/libraries/architecture/viewmodel) - To Store UI-related data that isnt destroyed on UI changes.
- [RecylerView](https://developer.android.com/guide/topics/ui/layout/recyclerview) - To Display data in a list format.

# 🏗️ Architecture Design


<img width="658" alt="Screenshot 2022-01-18 at 1 31 48 PM" src="https://user-images.githubusercontent.com/49483235/149895306-79dd64bb-7629-42f3-97dd-1796f4a65b40.png">

# This project is made for educational purposes so don't be shy of asking any questions about any concept from the app or about android developement. 
Do open <a href ="https://github.com/avidraghav/MVVM-TodoApp/issues" target="_blank">issues</a>
  and raise PRs to I'll try my best to assist you. :smiley:

## 📩 Contact

Don't let yourself get caught in the decision paralysis, just start learning and building. 😉

DM me at 👇

* Twitter: <a href="https://twitter.com/avidRaghav" target="_blank">@avidRaghav</a>
* LinkedIn: <a href="https://www.linkedin.com/in/avidraghav/">Raghav Aggarwal</a>
